package infohiding;

/**
 * Don't expose implementation prefer interfaces
 * @author hajo
 *
 */
public class DontExposeImplementation {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Client c = new Client(new A());
		c.execute();

	}
	
	// --------- TYPES ----------------------
	
	public static class Client {

		IA a;  // So what is this, really?? Don't know!
		
		public Client( IA a ){ // No implementation exposure
			this.a = a;
		}
		
		public void execute(){
			a.doA();
		}
	}
	
	
	public interface IA {
		public abstract void doA();
	}
	
	
	public static class A implements IA {

		@Override
		public void doA() {
		
		}
	}
}
