package innerlocalclass;

/**
 * Using anonymous inner classes
 * to emulating closures in Java
 * @author hajo
 *
 */
public class Main {

    public static void main(String[] args) {
        int x = 1;
        int y = 2;

        IClosure c = ClosureFactory.getClosure(x, y, 99); // 99 not used
        
        x = 3;
        y = 4;
     
        // Long time passing.... and then...
     
        System.out.println("Invoke: " + c.invoke());       
    }
}
