package comparable;

import java.math.BigDecimal;

/**
 * BigDecimal doesn't have consistent equals and 
 * compareTo methods (decimals counts)
 * @author hajo
 *
 */
public class InconsistentEqualComparable {
    public static void main(String[] args) {
        
        BigDecimal b1 = BigDecimal.valueOf(4.0);
        BigDecimal b2 = BigDecimal.valueOf(4.00);               
        System.out.println(b1.compareTo(b2) == 0); //They are equal (ok by API)
        System.out.println(b1.equals(b2)); // Should be false by API??!
       
    }
}
