package exception.checkedunchecked;

import java.io.FileReader;
import java.util.Scanner;

/**
 * Must handle checked exceptions (must not handle Runtime)
 * @author hajo
 *
 */
public class Main {

    public static void main(String[] args) {

        String filename = "nonexisting.txt";
        // FileNotFoundException?
        FileReader reader = null;
        //reader= new FileReader(filename);  // Checked MUST handle!

        // If reader == null -> NullPointerException, unchecked
        Scanner in = new Scanner(reader); 
        
        // NoSuchElementException?
        String input = in.next();
        
        // NumberFormatException? unchecked
        int value = Integer.parseInt(input);

    }
}
