package exception.tunneling;

import javax.swing.JOptionPane;

/**
 * Exception tunneling + try-finally
 * NOTE: To avoid need for resetting state try to use
 * failure atomicity
 * 
 * @author hajo
 *
 */
public class Main {

  public static void main(String[] args) {
    A a = new A(new B());

    try {
      a.doIt();
    } catch (MyException e) {
      // Finally catch the Exception
      JOptionPane.showConfirmDialog(null, e.getMessage());
    }

  }
}
