package mvc.eventbus;


/**
 * Model part of application
 * 
 * NOTE: The model should not handle services
 * Separations of concern! 
 * @author hajo
 *
 */
public class Model {
	
	private int i = 0;

	// Will change state
	public void setIt(int i) {
		this.setI(i);
		EventBus.INSTANCE.publish(new Event(Event.Tag.I_CHANGED, i));
	}

    public int getI() {
        return i;
    }

    public void setI(int i) {
        this.i = i;
    }
	
	

}
