package mvc;

import mvc.eventbus.Event;
import mvc.eventbus.EventBus;

/**
 * Adding messaging to the model by sub classing, OPC
 *
 * @author hajo
 *
 */
public class EventModel extends Model {

    @Override
    public void setI(int i) {
        super.setI(i);
        EventBus.INSTANCE.publish(new Event(Event.Tag.I_CHANGED, i));
    }

}
