package dp.visitor;

/**
 * The visitor must implement this.
 * Her's the matching on type (parameter to visit)
 * @author hajo
 *
 * @param <R>
 * @param <T>
 */
public interface IVisitor<R, T> {
    // R is return type, T is type of value in tree 
    public R visit(Leaf<T> leaf);
    public R visit(Node<T> node); 
}
