package dp.visitor.wildcards;

/**
 * Any element in tree must accept a visitor
 * @author hajo
 *
 * @param <T>
 */
public interface ITree<T> {
    public <R> R accept( IVisitor<R, ? super T> v);   
}
