package generic.methods;

import java.util.ArrayList;
import java.util.List;

/**
 *  Method inference from return type (and assignment)
 */
public class InferenceFromReturntype {

    public static void main(String[] args) {
       
  
        List<String> seq1 = make(); 
        List<Number> seq2 = make();
        List<String> seq3 = make(10); 
        List<Number> seq4 = make(10); 
        
        // Is type checking ok? ..yes
        seq1.add("aaa");
        //seq1.add(123); No
        seq2.add(123);
        //seq2.add("aaa"); No
        seq3.add("bbb");   
        seq4.add(456);

    }
    
    // ------------- Methods --------------------
    
    public static <T> ArrayList<T> make() {
        return new ArrayList<T>();
    }

    public static <T> ArrayList<T> make(int size) {
        return new ArrayList<T>(size);
    }
   
}
