package generic.overrideoverload;

/**
 * Override possible
 * @author hajo
 *
 */
public class GenericOverride {

    public static void main(String... args) {
        GenSuper<Integer> gt = new GenSuper<Integer>();
        gt.test(Integer.valueOf(5));
        
        // Use sub class
        gt = new GenSub<Integer>();
        // Overridden
        gt.test(Integer.valueOf(5));
    }

    public static class GenSuper<T> {
        public void test(T t) {
            System.out.println("Whoot");
        }

    }

    public static class GenSub<T> extends GenSuper<T> {
        @Override
        public void test(T t) {
            System.out.println("blaat");
        }
    }

}
