package generic.typecompatibility;

import java.util.Collection;
import java.util.List;

/**
 * Typecompatibility for parametrized types
 * @author hajo
 *
 */
public class ParameterizedTypeCompatibility2 {

    public static void main(String[] args) {
        List<? extends Number> en;
        List<Number> n = null;
        
        en = n;

        Collection<? extends Able> able = null;
        Collection<A> a = null;
        Collection<B> b = null;
        
        able = a;
        able = b;
        
        List<? super Integer> si = null;
        List<Number> i = null;
        List<Object> o = null;
        si = i;
        si = o;
    }

    
    // -------  Types -----------
    
    interface Able {

    }

    static class A implements Able {

    }

    static class B implements Able {

    }

}
