package hw4.out;
public class OrderValidator {
    /**
     * Validates the order and returns the order ID
     */
    private String validate(Order order) {
        String custID = order.getCustomerID();
        String itemID = order.getItemID();
        String product = order.getProduct();
        int qty = order.getQty();
        double price = order.getPrice();
        if (custID != null && itemID != null && !custID.equals("")
                && !itemID.equals("") && qty > 0 && price > 0.0) {
            return OrderUtils.getUniqueOrderId();
        }
        return null;
    }
}
