package hw5.out._3_1;
/**
 *  A stack that stores the maximum size over its entire lifetime
 *  @inv highWaterMark >= currentSize (&& MyStack invariants)
 */
class MonitorableStack extends MyStack {
    private static final long serialVersionUID = 1L;
    private int highWaterMark = 0;
    private int currentSize;
    public void push(Object article) {
        currentSize++;
        if (currentSize > highWaterMark) {
            highWaterMark = currentSize;
        }
        super.push(article);
    }
    public Object pop() {
        currentSize--;
        return super.pop();
    }
    public int maximumSizeSoFar() {
        return highWaterMark;
    }
}
