package sideeffect;

/**
 *
 * A side effect is when, besides a calculation of a result, something other
 * happens (state changes) Usage of methods (i.e. functions with side side
 * effects) should be minimized (but hard to avoid in imperative programming).
 *
 *
 * @author hajo
 *
 */
public class RefentialTransparency {

    private int i = 0; // Here's the state

    public int m(int j) {
        return i++ + j; // Causes a side effect, avoid
    }

}
