package inherit._super;

/**
 * Class overrides and hides, See JLS 15.11.2
 * @author hajo
 *
 */
public class B extends A {
    
    A a1 = this;
    // A a2 = super;  //No!
    
    // Hiding and overriding
    protected static void doIt() {
        System.out.println("B.doIt()");
    }

    protected void doOther() {
        System.out.println("B.doOther()");
    }
    
    public B (){
        System.out.println(this.getClass().getSimpleName());
        System.out.println(super.getClass().getSimpleName());  
        System.out.println(this.toString());
        System.out.println(super.toString());
        
        
        //System.out.println(super == this);  // No!
        //Object o = super;                   // No! 
        
        this.doIt(); // Bad style!
        this.doOther();
        
        super.doIt();
        super.doOther();
        
        ((A) this).doIt();
        ((A) this).doOther();
    }
    
}
