package covariance.clone;

/**
 * Covariant return types of clone
 * Possible but don't use because all others (libraries) probably
 * don't use
 * 
 * @author hajo
 *
 */
public class TestCovarianceClone {

  public static void main(String[] args) {
    B b1 = new B();
    B b2;
    C c1 = new C();
    C c2;
    // If covariant overriding can use this.
    b2 = b1.clone();
    System.out.println("b2 = " + b2 );
    
    // If not overriding clone in B we get an object back, must cast
    //b2 = (B) b1.clone();
    //System.out.println("b2 = " + b2 );
    
    // But this works even if B doesn't override clone
    c2 = c1.clone();
    System.out.println("c2 = " + c2 );
    
  }
}
