package equals.mixedtype.fixsymmetry;

public class A {

    protected int afield;

    public A() {
    }

    public A(int afield) {
        this.afield = afield;

    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + afield;
        return result;
    }

    @Override // Same as before
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof A)) {
            return false;
        }
        A other = (A) obj;
        return afield == other.afield;
    }
}
