package edu.gu.hajo.dict;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import edu.gu.hajo.dict.core.DictionaryEntry;

/**
 * Testing the converter
 * @author hajo
 *
 */
public class TestDictionaryEntryConverter {

	@Test
	public void testConvert() {
		DictionaryEntryConverter dec = new DictionaryEntryConverter();
		
		DictionaryEntry entry = dec.toObject("a=b,c,d,e,f");
		assertTrue(entry.getEntry().equals("a"));
		
		List<String> translations = entry.getTranslations();
		assertTrue(translations.size() == 5);
		
		
	}

}
