package threads.basic;

/**
 * Basic low level Threads, avoid!
 * 
 * TIP: Test this in debugger
 * 
 * @author hajo
 *
 */
public class Main { 
    public static void main(String[] args) {
        System.out.println("Main thread started...");
        
       // Threads will execute run() in X and Y 
       Thread t1 = new Thread(new X());
       Thread t2 = new Thread(new Y());
       Z z = new Z();  // Have my own thread...
       z.start();
       
       t1.setName("t1"); // Very good for debug
       t2.setName("t2");
       t1.start();
       t2.start();
       
       
       try {
        Thread.sleep(3000);
        z.stop();
    } catch (InterruptedException e) {
       
        e.printStackTrace();
    }
    System.out.println("Main thread died...");
    }    
}
