package rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;

import rmi.types.MyLocalClass;
import rmi.types.IMyRemoteInterface;

/**
 * Interface for the server must be on both client and server
 * @author hajo
 */
public interface IServer extends Remote {

    // Simple test
    public String ping() throws RemoteException;
   
    public MyLocalClass getByValue() throws RemoteException; 
   
    public IMyRemoteInterface getByReference() throws RemoteException;

    public void dumpData() throws RemoteException; 
}
