package innerclasses;

/**
 * Using inner classes
 * @author hajo
 *
 */
public class Main {

	public static void main(String[] args) {
		/*
		 * Inner class
		 */
		
		// No
		//InnerClass c = new InnerClass(); 

		// No, no enclosing instance
		//ClassWithInnerClass.InnerClass c = new ClassWithInnerClass.InnerClass(); 

		// The way to do it, strange...(inner public)
		ClassWithInnerClass o = new ClassWithInnerClass();
		ClassWithInnerClass.InnerClass c = o.new InnerClass();

		System.out.println(o.getData());
		System.out.println(c.getInnerData());
		System.out.println(c.getOuterData());

		/*
		 *  Inner static (nested) class 
		 */
		// Don't need any instance
		ClassWithInnerStaticClass.InnerClass ic = 
				new ClassWithInnerStaticClass.InnerClass();
		// Can't get outer data
		System.out.println(ic.getInnerData());
	}

}
