package nostate._static;

/**
 * Calling a static method
 * @author hajo
 *
 */
public class HowToCall {

    // NO objects!!
    public static void main(String[] args) {
    	A a = null;
    	
    	// This show that the reference isn't used (bad style)
        int i = a.sum(3, 4);
        
        // The way to do it
        int j = A.sum(3, 4);
       
        System.out.println(i + j);
    }
    
    // ------ TYPES ---------------
    
    public static class A {
    	public static int sum(int a, int b){
    		return a + b;
    	}
    }

}
