package immutable;

/**
 * Immutable instances must be given all data in constructor
 * 
 * @author hajo
 *
 */
public final class ImmutableInstance { //final

    
    public static void main(String[] args) {
        
        @SuppressWarnings("unused")
        MyImmutableClass m = new MyImmutableClass(3, 3.0, "3");
    }
    
    
    public static class MyImmutableClass {
        
        private final int i;
        private final double d;
        private final String s;
        
        // Note no other  constructor!
        public MyImmutableClass(int i, double d, String s){
            this.i = i;
            this.d = d;
            this.s = s;
        }

        public int getI() {
            return i;
        }

        public double getD() {
            return d;
        }

        public String getS() {
            return s;
        }
        
    }
}
