package innerclasses;

/**
 * Which effect has private??
 *
 * Inside this text we can access anything
 *
 * @author hajo
 *
 */
public class ScopeInner {

    private int outer;

    public int add(ScopeInner m) {
        // Can access m.i
        return outer + m.outer;
    }

    public void tryAccess() {
        // Accessible
        System.out.println(new Inner().i);
        System.out.println(new OtherInner().oi);
    }

    public class Inner {

        // Can access i
        private int i = 1;
        private int i2 = outer;

        {   // Can access other inner class
            System.out.println(new ScopeInner().new OtherInner().oi2);
        }
    }

    public class OtherInner {

        private int oi = 2;
        private int oi2 = outer;

        {   // Can access other inner class
            System.out.println(new ScopeInner().new Inner().i2);
        }

    }

}
