package innerclasses;

/**
 * Using inner classes
 *
 * @author hajo
 *
 */
public class TestInnerClasses {

    public static void main(String[] args) {
        /*
         * Inner (non-static) 
         */
	    // No
        //InnerClass c = new InnerClass(); 

        // No, no enclosing instance
        //ClassWithInnerClass.InnerClass c = new ClassWithInnerClass.InnerClass(); 
        // The way to do it, strange...(inner public)
        OuterClass o = new OuterClass();
        System.out.println(o.getInnerData());  // Inner instance created!

        OuterClass.InnerClass c = o.new InnerClass();

        System.out.println(o.getData());
        System.out.println(c.getInnerData());
        System.out.println(c.getOuterData());

        /*
         *  Inner static (nested) class 
         */
        // Don't need any instance
        OuterClassStatic.InnerClass ic
                = new OuterClassStatic.InnerClass();
        // Can't get outer data
        System.out.println(ic.getInnerData());
    }
}
