package singleton;


/**
 * One way of implement a Singleton
 * 
 * Pros 
 * ---- 
 * Single instance guaranteed by system
 * 
 * Cons 
 * ----- 
 * Can't use extends (implements ok)
 * (The direct superclass of an enum type named E
 * is Enum<E>)
 * 
 * @author hajo
 * 
 */
public enum EnumSingleton {
	INSTANCE;

	public void doIt() {
		System.out.println("doIt");
	}

}
