package statics;


/**
 * Testing different static issues
 * @author hajo
 *
 */
public class TestStatic {

    public static void main(String[] args) {
    	//testStaticClass();
        //testStaticOverload();
        //testInstanceAndClass();
        testHiding();
        //testUnusedReference();
    }

    private static void testStaticClass() {
        System.out.println(StaticClass.cube(4));
    }

    private static void testStaticOverload() {
        StaticOverload.doIt();
        StaticOverload.doIt(5);
        new StaticOverload().doIt("Blabla");     
   }

    private static void testInstanceAndClass() {
        InstanceAndClass.doIt();
        System.err.println(InstanceAndClass.i);
        new InstanceAndClass().doOther();
         System.err.println(new InstanceAndClass().j);
    }

    private static void testUnusedReference() {
        new UnusedReference().test();
    }

    private static void testHiding() {
        new Hiding().test();
    }
    
}
