package polymorphism.variables;

/**
 * No polymorphism what ever for variables
 * @author hajo
 *
 */
public class NoPolymorphismForVariables {

    public static void main(String[] args) {
        A a = new B();
        B b = new B();
  
        // Ok, static type
        String s = a.s;  // Bad style      
        System.out.println(s);
        
        // No
        //Integer i = a.s;
        
        Integer j = b.s;
        System.out.println(j);
    }
    
    // --------- TYPES --------------
  
    public static class A {
    	public String s = "abc";
    }
    
    public static class B extends A {
        // Have string here also
        //public String s = "abc";
        public Integer s = 1;
    }    
}
