package subtyping;

/**
 * Many subtypes of a type
 * @author hajo
 *
 */
public class MultipleSubtypes {
	public static void main(String[] args) {
		IA a1 = new ImplA1();
		IA a2 = new ImplA2();
		
		// Both can doA
		a1.doA();
		a2.doA();
	}
	
	public interface IA {
		public abstract void doA();
	}

	public static class ImplA1 implements IA {
		@Override
		public void doA() {
			System.out.println("ImplA doing A");
		}
	}
	
	public static class ImplA2 implements IA {
		@Override
		public void doA() {
			System.out.println("ImplA2 doing A");
		}

	}

	
}
