package overload;

/**
 * Possible ambiguous methods when combining overloading/conversion
 *
 * Compiler searches for the best match in declared type
 *
 * @author hajo
 *
 */
public class OverloadingAmbigous {

    public void test() {
        A a = new A();
        System.out.println("Twice as much is " + a.add(1, 1));

        B b = new B();
        // No, ambiguous
        //System.out.println("Twice as much is " + b.add(1, 1));// Try change last 1 to 1.0	

    }

    // ---------- Types ------------------
    public class A {
        /*public double add(double d, int i) {
         return d + i;
         }*/

        public double add(int i, double d) { // Try change double to int
            return i + d;
        }
    }

    public class B extends A {

        public double add(double d, int i) {
            return d + i;
        }

    }

}
