package overload;

/**
 * Overloading is compile time
 *
 * @author hajo
 *
 */
public class OverloadingIsCompiletime {

    public void test() {
        A a1 = new A();
        A a2 = new B();

        // Methods for a1 in A or superclass (no overriding so no method in subclass)!
        a1.doit(1);  // Conversion 1 -> 1.0
        a2.doit(1); // Optimal method in runtime type not selected
        
        
        B b = new B();
        // Method inherited
        b.doit(1.0);
    }

    // ------------- Types ---------------------
 
  
    public class A  {

        public void doit(double i) {
            System.out.println("Do it double");
        }
    }

    public class B extends A {
        // NOT overriding
        public void doit(int i) {
            System.out.println("Do it int");
        }
        
        /* Inherited */
        /*public double doit(double i) {
            System.out.println("Do it double");
            return i;
        }*/
        
    }

}
