package abstractclass;

public class UsingAbstractToRemoveDuplicateCode {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		IA ia = new ImplA1();
		
		ia.doit(); // Have implementation

	}
	
	// --------------- TYPES -----------------
	
	public interface IA {
		public void doit();
	}
	
	// Move common code to abstract parent class
	public static abstract class AbstractA implements IA {
		// Code common to ImplA1 and ImplA2 
		@Override
		public void doit(){
			System.out.println("Doit");
		}
	}
	
	public static class ImplA1 extends AbstractA {
		
	}
	
	public static class ImplA2 extends AbstractA {
		
	}

}
