package exception.override;

import java.io.FileNotFoundException;
import java.io.IOException;

public class ExceptionOverriding {

    
    
    public interface IA {
        // IOException :> FileNotFoundException
        public void doit() throws IOException;
        public void doOther() throws FileNotFoundException;
    }
    
    public static class A implements IA {
        @Override
        public void doit() throws IOException {
        }

        @Override
        public void doOther() /*throws IOException*/ {   // Not super type       
        }    
    }
    
    public static abstract class B implements IA {
        @Override
        public void doit(){
        }
    }
    
    public static abstract class c implements IA {
        @Override
        public void doit() throws FileNotFoundException { // Sub type
        }
    }
    
    
}
