package option;

/**
 * Interface used to avoid null's
 *
 * @author hajo
 *
 * @param <T>
 */
// T stands for any type, Option is a "generic" type more later
public interface Option<T> {

    public boolean hasValue();

    public T get();

    public T getOrElse(T alternative);
}
