package generic.wildcard.restrictions;

import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;

/**
 *
 * Restrictions on <? extends T > collection
 * @author hajo
 *
 */
public class RestrictionsUpperBound {

	public static void main(String[] args) {

	    // Any of these are valid
	    List<? extends Number> list = new ArrayList<Number>();  
	    //List<? extends Number> list = new ArrayList<Integer>(); 
	    //List<? extends Number> list = new ArrayList<Double>();  

	    // Read 
        Object o = list.get(0);
        Number n = list.get(0);
        /* Can't get
        Integer i = list.get(0);
        Double d = list.get(0);*/
	    
	    
	    // Write
	    /* 
	    You can't add an Integer because list could be pointing at a List<Double>.
	    You can't add a Double because list could be pointing at a List<Integer>.
	    You can't add a Number because list could be pointing at a List<Integer>.
	    Yuo can add null..
	    */
	    list.add(null);
	    
	   
	    
	    // ----------- Nested wild card ---------------------------------
        // Can add!!
        List<List<?>> lists = new ArrayList<>();
        lists.add(Arrays.asList(1, 2, 3));
        lists.add(Arrays.asList("four", "five"));
        System.out
                .println(lists.toString().equals("[[1, 2, 3], [four, five]]"));
	    

	}

}
