package reflection.plugin.pluginhome;

import reflection.plugin.IFramework;
import reflection.plugin.IPlugin;
import reflection.plugin.MissionData;

/**
 * Another concrete plugin
 * @author hajo
 *
 */
public class Stalingrad implements IPlugin {

    IFramework frameWork;
    
    public Stalingrad(){
       System.out.println("Instantiating "+ this);
    }
   
    public void hook(IFramework framWork) {
        this.frameWork = framWork;
        System.out.println("Hooked into framework "+ this);
    }

    public void setMissionData(MissionData m) {
        frameWork.doSomeService(m);
    }

    public void upDate() {
        System.out.println("Stalingrad: upDated");
    }
}
