package dp.visitor;

/**
 * Just the structure no calculations here
 * @author hajo
 *
 * @param <T> data in Leaf
 */
public class Leaf<T> implements ITree<T> {

    private final T t;

    public Leaf(T t) {
        super();
        this.t = t;
    }

    @Override
    public <R> R accept(IVisitor<R, T> v) { 
        return v.visit(this);
    }

    public T getIt() {
        System.out.println("Leaf");
        return t;
    }
}
