package generic.basic;

/**
 * Very simple basic generic class
 *
 * To create parameterized type and instantiate
 *
 * BasicGenericClass<String> b = new BasicGenericClass<>()
 *
 * @author hajo
 * @param <T>
 *
 */
// Possible: public class GenericClass<T, E> {
public class GenericClass<T> {

    // Refer to with raw type GenericClass.CONSTANT)
    public static final int CONSTANT = 0;

    private T data;
    // No static, shared by all parameterized types
    //private static T otherData;

    // Ok, no type variable
    private static int i;

    public GenericClass() {
    }

    public void setData(T data) {
        this.data = data;
    }

    public T getData() {
        return data;
    }

    /* No use of type variable ans static
     public static setData( T t ){
    	
     }*/
    public int getI() {
        return i;
    }

}
