package reflection.plugin.pluginhome;

import reflection.plugin.IFramework;
import reflection.plugin.IPlugin;
import reflection.plugin.MissionData;

/**
 * A concrete plugin
 * @author hajo
 *
 */
public class Narva implements IPlugin {

    private IFramework frameWork;
    
    public Narva(){
       System.out.println("Instantiating "+ this);
    }
   
    public void hook(IFramework framWork) {
        this.frameWork = framWork;
        System.out.println("Hooked into framework "+ this);
    }

    public void setMissionData(MissionData m) {
        frameWork.doSomeService(m);
    }

    public void upDate() {
        // Possible down load data here
        System.out.println("Narva: upDated");
    }
}
    