package hw5.out._5_1;
import java.awt.Color;
public class ColorPoint extends Point {
   private final Color color; //Significant field
   public ColorPoint(int x, int y, Color color) {
      super(x, y);
      this.color = color;
   }
   public Color getColor() {
      return color;
   }
   @Override
   public boolean equals(Object o) {
      if (!(o instanceof ColorPoint)) {
         return false;
      }
      ColorPoint cp = (ColorPoint) o;
      return super.equals(o) && cp.color == color;
   }
}
