package hw6.out;
public class Color {
    private int red;
    private int green;
    private int blue;
    public Color(int r, int g, int b) {
        if (!isRBGColor(r, g, b)) {
            throw new IllegalArgumentException();
        }
        this.red = r;
        this.green = g;
        this.blue = b;
    }
    public void setColor(int r, int g, int b) {
        if (!isRBGColor(r, g, b)) {
            throw new IllegalArgumentException();
        }
        this.red = r;
        this.green = g;
        this.blue = b;
    }
    public int[] getColor() {
        int[] retVal = new int[3];
        retVal[0] = red;
        retVal[1] = green;
        retVal[2] = blue;
        return retVal;
    }

    public void invert() {
        red = 255 - red;
        green = 255 - green;
        blue = 255 - blue;
    }
    private static boolean isRBGColor(int red, int green, int blue) {
        return (0 <= red && red <= 255) && ( 0 <= green && 
                green <= 255 ) &&  ( 0<= blue && blue <= 255);
    }
}
