package hw6.out;
public class Person extends Thread {
    private String name;
    private Person whomToAsk;
    public Person(String name) {
        this.name = name;
    }
    public void setWhomToAsk(Person whomToAsk) {
        this.whomToAsk = whomToAsk;
    }
    public String toString() {
        return name;
    }
    private void getAQuestionFrom(Person p) {
        try {
            System.out.println(this + " says: I got a question from " + 
                    p + " start thinking...");
            // Think a while before answering...
            Thread.sleep((int) (Math.random() * 1000) + 1000);
            System.out.println(this + " finished thinking");
            p.getAnAnswerFrom(this);
        } catch (InterruptedException e) {
            Thread.currentThread().interrupt();
        }
    }
    private void getAnAnswerFrom(Person p) {
        System.out.println(this + " says: I got an answer from " + p);
    }
    public void run() {
        whomToAsk.getAQuestionFrom(this);
    }
    public static void main(String[] args) {
        Person pelle = new Person("Pelle");
        Person daniel = new Person("Daniel");
        pelle.setWhomToAsk(daniel);
        daniel.setWhomToAsk(pelle);
        pelle.start();
        daniel.start();
    }
}