package declarative;

public class TailRecursiveToImperative {

    /**
     * @param args
     */
    public static void main(String[] args) {
        A a = new A();

        int i = a.fr(6);
        System.out.println(i);

        i = a.fi(6);
        System.out.println(i);

    }

    public static class A {
        // Tail recursive
        public int fr(int x) {
            if (p(x)) {
                System.out.print("g");
                return g(x);
            } else {
                System.out.print("h");
                return fr(h(x));
            }
        }

        // Imperative
        public int fi(int x) {
            while (!p(x)) {
                x = h(x);
                System.out.print("h");
            }
            System.out.print("g");
            return g(x);
        }

        private boolean p(int x) {
            return x <= 0;
        }

        private int h(int x) {
            return x - 1;
        }

        private int g(int x) {
            return x;
        }
    }

}
