package sideeffect;

/**
 * 
 * A side effect is when, besides a calculation of a result,
 * something other happens (state changes)
 * Usage of methods (i.e. functions with side side effects) should
 * be minimized (but hard to avoid in imperative programming).
 * 
 *
 * @author hajo
 * 
 */
public class RefentialTransparency {

	public static void main(String[] args) {
		MyClass c = new MyClass();

		// If a functional program this would always be 0, but this is
		// imperative...
		System.out.println(c.m(99) - c.m(99));

	}

	
	// Scroll down for solution
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public static class MyClass {
		private int i = 0; // Here's the state

		public int m(int j) {
			return i++ + j; // Causes a side effect, avoid
		}
	}
}
