package testing;

/**
 * Class under test (CUT)
 * 
 * This is a very trivial class so in reality
 * there's no need for testing
 * This is just an example
 * 
 * NOTE: set/get methods never tested.
 * 
 * @author hajo
 *
 */
public class CUT {

   private int bound; 
   
   // Must have
   public CUT(){ 
   }
  
   public void setDatasetUpperBound(int bound){
	   if( bound < 0){
		   throw new IllegalStateException("Bound must not be negative: " + bound); 
	   }
       this.bound = bound;
   }
   
   public int getComplicatedResult(){
   	int result = 0;
       // Get sum of squares
   	for(int i = 0 ; i < bound ; i++){
       	result += i * i;
       }
       return result; 
   }
    
}
