package declarative;

public class TestTailRecursiveToImperative {

    /**
     * @param args
     */
    public static void main(String[] args) {

        int i = fr(6);
        System.out.println(i);

        i = fi(6);
        System.out.println(i);

    }

    // Tail recursive
    public static int fr(int x) {
        if (p(x)) {
            System.out.print("g");
            return g(x);
        } else {
            System.out.print("h");
            return fr(h(x));
        }
    }

    // Imperative version of the above
    public static int fi(int x) {
        while (!p(x)) {
            x = h(x);
            System.out.print("h");
        }
        System.out.print("g");
        return g(x);
    }

    private static boolean p(int x) {
        return x <= 0;
    }

    private static int h(int x) {
        return x - 1;
    }

    private static int g(int x) {
        return x;
    }

}
