package clone.inheritance;

/**
 * Approx same previous basic clone implementation, but shows
 * the hidden type casting done by the system (see class B)
 * 
 * @author hajo
 * 
 */
public class Main {

	public static void main(String[] args) {
		A a1 = new A();
		A a2;
		B b1 = new B();
		B b2;

		// NOT using covariant return types
		a2 = (A) a1.clone();
		a2.setI(222);

		// These should differ
		System.out.println("a1 = " + a1 + " a1.i " + a1.getI());
		System.out.println("a2 = " + a2 + " a2.i " + a2.getI());

		b2 = (B) b1.clone();
		b2.setI(888);
		b2.setJ(999);
		
		// These should differ
		System.out.println("b1 = " + b1 + " b1.i " + b1.getI() + " b1.j "
				+ b1.getJ());
		System.out.println("b2 = " + b2 + " b2.i " + b2.getI() + " b2.j "
				+ b2.getJ());

		
	}

}
