package copyctor;

public class A {

  private int value = 999;
  private String[] strs = new String[5];

  public A() {
  }

  // Copy ctor, Ok deep copy
  // But will change type for subclasses
  public A(A a) {
    value = a.value;
    strs = new String[5];
    for (int i = 0; i < strs.length; i++) {
      strs[i] = a.strs[i]; // Strings immutable
    }
  }

  @Override
  public String toString() {
    return getClass().getName() + "@" + Integer.toHexString(hashCode()) + ":"
        + value + ":" + strs;
  }
}
