package copyctor.uno;

public class B extends A {

    // Run before ctor
    private String[] bStrs;

    public B() {
    }

    // Copy ctor, OK deep copy
    protected B(B b) {
        super(b);
        bStrs = new String[b.bStrs.length];
        for (int i = 0; i < bStrs.length; i++) {
            bStrs[i] = b.bStrs[i];
        }
    }

    // Covariant return type
    @Override
    public B copyOf() {
    	 System.out.println("B copyOf, runtime type of this is : " + this.getClass().getName()); 
        // Will call protected ctor
        return new B(this);
    }
/*
    @Override
    public String toString() {
        return getClass().getName() + "@" + Integer.toHexString(hashCode())
                + ":" + super.toString() + bStrs;
    }
*/
    public void setBStrs(String[] bStrs) {
        this.bStrs = bStrs;
    }

    public String[] getString() {
        return bStrs;
    }
}
