package dp.template;


public abstract class AbstractAB {

    public final void doItGeneral(){
        System.out.print("Start doing it general...");
        System.out.print("...doing...");
        doItSpecial();  // Let subclass decide
        System.out.print("...doing...");
        System.out.println("done");
    }
    
    // Subclasses *should* override (special contract) 
    protected abstract void doItSpecial();
}
