package clone.constructor;

/**
 * No constructor may be used when implementing clone
 * 
 * ClassCastException
 * 
 * @author hajo
 *
 */
public class TestCloneContructor {
  
    public static void main(String[] args) throws CloneNotSupportedException  {
        A a1 = new A();
        B b1 = new B();
        
        
        System.out.println("a1 is cloneable: " + (a1 instanceof Cloneable));
        System.out.println("a1 : " +  a1);
        A a2 = (A) a1.clone(); 
        System.out.println("a2 : " +  a2);
        
        System.out.println("b1 is: " + b1);
        System.out.println("b1 is cloneable: " + (b1 instanceof Cloneable)); 
      
             
        B b2 = (B) b1.clone(); 
        System.out.println("b2 is: " + b2);
        System.out.println("b2 is cloneable: " + (b2 instanceof Cloneable));        
    }
    
  
    
   
}
