package clone.inheritance;

/**
 * No exception handling needed
 *
 * @author hajo
 *
 */
// Cloneable from A
public class B extends A {

    private int j = 222;

    @Override
    public Object clone() {  // No throws here
        Object o = super.clone();
        // Dynamic type is B !!!
        System.out.println("Inside B: super.clone type is " + o.getClass());
        B b = (B) o;
        // No references here, just return
        return b;
    }

    public int getJ() {
        return j;
    }

    public void setJ(int j) {
        this.j = j;
    }
}
