package dp.decorator;

/**
 * Abstract decorator class - note that it implements Window
 *
 * @author hajo
 */
public abstract class AbstractWindowDecorator implements IWindow {

    protected IWindow decoratedWindow; // the Window being decorated

    public AbstractWindowDecorator(IWindow decoratedWindow) {
        this.decoratedWindow = decoratedWindow;
    }
        // Possible if something in common
    //abstract public void draw(); 
    //abstract public String getDescription(); 
}
