package equals.sametype;

/**
 * Baseclass
 *
 * @author hajo
 *
 */
public class Person {

    protected String pNumb; // Significant field

    public Person() {
    }

    public Person(String pNumb) {
        this.pNumb = pNumb;
    }

    @Override
    public int hashCode() {
        final int PRIME = 31;
        int result = 1;
        result = PRIME * result + ((pNumb == null) ? 0 : pNumb.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {// Same type!!
            return false;
        }
        final Person other = (Person) obj;
        if (pNumb == null) {
            if (other.pNumb != null) {
                return false;
            }
        } else if (!pNumb.equals(other.pNumb)) {
            return false;
        }
        return true;
    }

}
