package inherit.exception;

import java.io.IOException;

/**
 * Exceptions and inheritance
 * @author hajo
 *
 */
public class TestInheritanceException {

    public static void main(String[] args) {
        A a1 = new A();
        IA ia = a1;
        A a2 = new B();
        B b = new B();
      
        a1.doItChecked();  // Not handled;
        try {
            ia.doItChecked();  //MUST handle    
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        a1.doItUNChecked(); // Not forced to handle
        
        a2.doItChecked();  // Must handle
        
        b.doItChecked();  // Must NOT handle
    }

}
