package liskov;

/**
 * A factory to hide what we get
 * @author hajo
 *
 */
public class Factory {
	
	public static Rectangle getSomething() {
		// Rectangle :> Square
		// So type system says Square
		// is safe to use instead of Rectangle
		// (Sadly: syntactic sub type not semantic sub type)
		return new Square();
	}
}
