package edu.gu.cid.translator.gui;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import edu.gu.cid.translator.ctrl.IOCtrl;


/**
 * Small panel for two buttons, clear and backspace
 * 
 * @author hajo
 * 
 */
@SuppressWarnings("serial")
public class ButtonPanel extends JPanel implements ActionListener {

	private final JButton backspace = new JButton("Backsp");
	private final JButton clear = new JButton("Clear");
	

	public ButtonPanel(IOCtrl ioCtrl) {
	
		init();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		
	}

	private void init() {
		backspace.addActionListener(this);
		clear.addActionListener(this);
		this.setLayout(new GridLayout(3, 1));
		this.add(backspace);
		this.add(clear);
	}

}
