package threads.basic;

/**
 * This is a class possible for some Thread to run
 * (because it implements runnable)
 * @author hajo
 *
 */
// Must implement runnable
public class X implements Runnable {

	@Override
	public void run() {
		while (true) {
			// Print my name
			System.out.println("I'm X I'm quicker.... run by "
					+ Thread.currentThread().getName());
			try {
				// Let actual thread sleep 1 sec
				Thread.sleep(1000);
			} catch (InterruptedException e) {

				e.printStackTrace();
			}
		}
	}
}
