package threads.concurrentcollections;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class UseConcurrentCollection {

   
    public static void main(String[] args) {
      
    }

    public class DoItMySelf {

        Map<String, String> map = new HashMap<>();

        public synchronized void add(String key, String value) {
            map.put(key, value);
        }
    }

    public class UseConcurrent {
        // Concurrent collection
        Map<String, String> map = new ConcurrentHashMap<>();

        // No synchronized
        public void add(String key, String value) {
            map.put(key, value);
        }
    }

}
