package threads.basic;

/**
 * This is a class possible for some Thread to run
 * (because it implements runnable)
 * @author hajo
 *
 */
//Must implement runnable
public class Y implements Runnable {

    @Override
    public void run() {
        while (true) {
            System.out.println("I'm Y run by "
                    + Thread.currentThread().getName());
            try {
                // Let actual thread sleep 2 sec
                Thread.sleep(2000);
            } catch (InterruptedException e) {

                e.printStackTrace();
            }
        }

    }
}
