package singleton;

/**
 * Getting objects as singletons
 * @author hajo
 *
 */
public class Main {
	public static void main(String[] args) {
		ClassSingleton s = ClassSingleton.getInstance();
		s.doIt();
		
		EnumSingleton es = EnumSingleton.INSTANCE;
		es.doIt();
		
		SingletonFactory.MyClass m = SingletonFactory.getMyClass();
		m.doIt();
	}
}
