package statics;

/**
 * 
 * Any object reference discarded when calling static method
 * @author hajo
 *
 */
public class UnusedReference {

    public void test() {

        UnusedReference a = null;

        // This show that the reference isn't used (bad style)
        // when calling static methods
        int i = a.sum(3, 4);

        // The way to do it
        int j = UnusedReference.sum(3, 4);

        System.out.println(i + j);
    }

    // ------ TYPES ---------------
    public static int sum(int a, int b) {
        return a + b;
    }

}
