package edu.gu.hajo.trie;

import java.util.List;

/**
 * A Trie implementation
 *
 */
public class ConnectableTrie implements IConnectableTrie {

    private ConnectableTrie() {
    }

    // Factory method
    public static IConnectableTrie newInstance() {
        return new ConnectableTrie();
    }

    @Override
    public TrieNode insert(String key) {
        return null;
    }

    @Override
    public boolean contains(String key) {
        return false;
    }

    @Override
    public List<String> getValues(String key) {
        return null;
    }

    @Override
    public List<String> getKeys(String prefix) {
        return null;
    }

}
