package polymorfism.adhoc;

/**
 * Possible ambiguous methods when combining overloading/conversion
 * 
 * Compiler searches for the best match in declared type
 * @author hajo
 *
 */
public class OverloadingAmbigous {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		A a = new A();
		System.out.println("Twice as much is " + a.add(1, 1));	
		
		B b = new B();
		// No, ambiguous
		//System.out.println("Twice as much is " + b.add(1, 1));// Try change last 1 to 1.0	
		
	}

	// ---------- TYPES ------------------
	
	public static class A {
		/*public double add(double d, int i) {
			return d + i;
		}*/
		public double add(int i, double d) { // Try change double to int
			return i + d;
		}	
	}
	
	public static class B  extends A {
		public double add(double d, int i) {
			return d + i;
		}
		
	}
	
}
